#! /usr/bin/env python

class peProtocolGenerator:
  def __init__(self, fileToWrite):
    self.fileToWrite = fileToWrite

  def generateProtocol(self):
    self.fileToWrite.write('''\
    
protocol "Evader" (evaderPos : observable Pos, found : observable Bool)
begin
	-- The evader makes an arbitrary move, including have a rest on current position


	do True -> <<ForwardOne>>
        [] True -> <<BackwardOne>>
        [] True -> <<Rests>>
	od


end 

-- The pursuer  starts from the leftmost position, moves to the right 
-- until it cannot move any further, then moves back to the 
-- leftmost position. Repeat the process infinitely.
protocol "Pursuer " (
        pursuerPos: observable Pos, direction: observable Direct, found: observable Bool)
begin

	do direction == 0  -> <<ForwardOne>>
	[] direction == 1  -> <<BackwardOne>>
	od

	
end''')
